System Test application for the OpenDOF Java Internal Domain Management Command Line/Cred-Gen Tools 
====
***

##Description

The OpenDOF Domain Management Command Line/Credential Generator Tool test applications provide a simple way to verify correct functionality and system behaviours of the OpenDOF Domain Management Command Line/Cred-Gen Tools. Please note these tests are not unit tests, but system tests.  Unit tests can be found under the respective library's source.

##Testing Disclaimer

Please note that the code supplied within this module is highly designed 
around working with the [Panasonic Distributed Testing Framework](https://github.com/PSLCL/testing-framework).
As such, there are certain coding methodologies and test design concepts throughout.

Though these tests are system tests, they are designed to fail immediately 
if any problems arise throughout execution, for quicker retrieval of results.
In a real system application, the developer should provide a means for proper handling 
of failures in order to maintain the system. 

Due to the nature of this module, the source code should NOT be used in anyway for training, 
learning, or as sample code for providing proper application design with OpenDOF projects. 
Instead if one is interested in learning about proper application design they should reference 
the particular SDK or training modules provided by OpenDOF. 
These can be found in the GIT repository of the module that this testing module is testing or 
you can also look at the [Downloads page](https://opendof.org/downloads/) for OpenDOF.

##Build Instructions

This project uses [Apache Ant](http://ant.apache.org/) and [Apache
Ivy](http://ant.apache.org/ivy/) to build and resolve dependencies. In
addition, a Java Development Kit (JDK) of 1.7 or greater is required.

To build, make sure any dependencies are available in a configured Ivy
repository, copy the desired ivy.<version_number>.xml that you want to 
build to a new file named ivy.xml, and execute `ant dist` in the root of 
the project (this is the default ant target). To publish the build to your local ivy
repository (and make it available for other builds to depend on),
execute `ant publish`.

If you plan to make a complete distribution including source, you will
also need to use the `dist-src` and `publish-src` targets. Typically,
these would be executed prior to the binary build (`dist` and `publish`
targets), since they require a clean directory.

##Runtime Prerequisites

A Java Runtime Environment (JRE) of 1.7 or greater is required. The Java
Cryptography Extension (JCE) Unlimited Strength Jurisdiction Policy
Files must be properly installed to support 256-bit AES encryption. This
is usually specific to the version of the JRE you are using, and
available from your JRE provider.

The security policy file, java.security, is used to configure the random
number generator. It is important to note which securerandom.source is
used in order to make sure you are using one that is as
cryptographically secure as possible.

##How to Report an Issue

Issues can be reported through the issue tracking system of the OpenDOF
Project at <https://issue.opendof.org>

Information on the process for reporting an issue can be found at
<https://opendof.org/report-an-issue>.